Index: TvEngine3/TVLibrary/TvService/Epg/EpgGrabber.cs
===================================================================
--- TvEngine3/TVLibrary/TvService/Epg/EpgGrabber.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvService/Epg/EpgGrabber.cs	(working copy)
@@ -25,6 +25,8 @@
 using TvLibrary.Log;
 using TvLibrary.Interfaces;
 using System.Threading;
+using TvLibrary.Implementations;
+using TvLibrary.Implementations.Helper.Providers;
 
 namespace TvService
 {
@@ -114,12 +116,20 @@
       {
         _epgReGrabAfter = 240;
       }
+
+      bool providerEPGGrabbingEnabled = Provider.Instance.ProviderEPGGrabbingEnabled;
+
       TransponderList.Instance.RefreshTransponders();
-      if (TransponderList.Instance.Count == 0)
+      if (TransponderList.Instance.Count == 0 && !providerEPGGrabbingEnabled)
       {
         return;
       }
-      Log.Epg("EPG: grabber initialized for {0} transponders..", TransponderList.Instance.Count);
+      if (TransponderList.Instance.Count >= 1)
+        Log.Epg("EPG: grabber initialized for {0} transponders..", TransponderList.Instance.Count);
+
+      if (providerEPGGrabbingEnabled)
+        Log.Epg("EPG: grabber initialized for configured providers");
+
       _isRunning = true;
       IList<Card> cards = Card.ListAll();
 
@@ -261,6 +271,10 @@
       if (type == CardType.Analog || type == CardType.RadioWebStream)
         return;
 
+      //  Grab all providers, return if one was started successfully
+      if (epgCard.GrabProviderEPG(_epgReGrabAfter))
+        return;
+
       while (TransponderList.Instance.GetNextTransponder() != null)
       {
         //skip transponders which are in use
Index: TvEngine3/TVLibrary/TvService/Scheduler/Scheduler.cs
===================================================================
--- TvEngine3/TVLibrary/TvService/Scheduler/Scheduler.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvService/Scheduler/Scheduler.cs	(working copy)
@@ -81,6 +81,11 @@
     /// </summary>
     private int _maxRecordFreeCardsToTry;
 
+    /// <summary>
+    /// Lookup table for new 'series link' schedule - used to guarantee the scheduler will only spawn a linked program once
+    /// </summary>
+    private readonly Dictionary<int, int> _scheduleLastRecordingStarted = new Dictionary<int, int>();
+
     #endregion
    
     #region ctor
@@ -198,6 +203,7 @@
           card = new VirtualCard(user);
           return true;
         }
+
       }
       return false;
     }
@@ -675,6 +681,10 @@
         case ScheduleRecordingType.WeeklyEveryTimeOnThisChannel:
           isTimeToRecord = IsTimeToRecordWeeklyEveryTimeOnThisChannel(schedule, currentTime);
           break;
+
+        case ScheduleRecordingType.SeriesLink:
+          isTimeToRecord = IsTimeToRecordSeriesLink(schedule, currentTime);
+          break;
       }
       return isTimeToRecord;
     }
@@ -757,6 +767,84 @@
       return isTimeToRecord;
     }
 
+    /// <summary>
+    /// Gets if its time to record a series link recording, doesnt record directly, spawns a new record once schedule
+    /// </summary>
+    /// <param name="schedule"></param>
+    /// <returns></returns>
+    private bool IsTimeToRecordSeriesLink(Schedule schedule, DateTime currentTime)
+    {
+      Channel scheduleChannel = schedule.ReferencedChannel();
+
+      if (scheduleChannel == null)
+        return false;
+
+      if (schedule.SeriesId == 0)
+        return false;
+
+      TvDatabase.Program currentProgram = scheduleChannel.GetProgramAt(currentTime.AddMinutes(schedule.PreRecordInterval), schedule.SeriesId);
+
+      
+
+      if (currentProgram != null)
+      {
+
+        //  If this schedule has already spawned this program, skip
+        if (_scheduleLastRecordingStarted.ContainsKey(schedule.IdSchedule) && _scheduleLastRecordingStarted[schedule.IdSchedule] == currentProgram.IdProgram)
+        {
+          Log.Write("Scheduler: Record once for \"" + schedule.ProgramName + "\" has already been spawned, skipping");
+          return false;
+        }
+
+        if (currentTime >= currentProgram.StartTime.AddMinutes(-schedule.PreRecordInterval) &&
+            currentTime <= currentProgram.EndTime.AddMinutes(schedule.PostRecordInterval) &&
+            currentProgram.SeriesId > 0 &&
+            currentProgram.SeriesId == schedule.SeriesId)
+        {
+          if (!schedule.IsSerieIsCanceled(currentProgram.StartTime))
+          {
+            Log.Write("Scheduler: Time to record series link - " + schedule.ProgramName);
+
+            bool createSpawnedOnceSchedule = CreateSpawnedOnceSchedule(schedule, currentProgram);
+
+
+            if (createSpawnedOnceSchedule)
+            {
+              //  Add the last program spawned to the lookup to prevent this schedule spawning this program again
+              if (_scheduleLastRecordingStarted.ContainsKey(schedule.IdSchedule))
+              {
+                Log.Write("Scheduler: Updating last spawned program id to " + currentProgram.IdProgram.ToString() + " for schedule id " + schedule.IdSchedule.ToString());
+
+                _scheduleLastRecordingStarted[schedule.IdSchedule] = currentProgram.IdProgram;
+                Log.Write("Scheduler: Done last action");
+
+              }
+
+              else
+              {
+                Log.Write("Scheduler: Adding last spawned program id to " + currentProgram.IdProgram.ToString() + " for schedule id " + schedule.IdSchedule.ToString());
+
+                _scheduleLastRecordingStarted.Add(schedule.IdSchedule, currentProgram.IdProgram);
+              }
+
+              //  If this is the last episode in the series link, we want to delete the schedule
+              if (currentProgram.SeriesTermination == 1)
+              {
+                Log.Write("Scheduler: This is the last episode in the series.  Deleting series link schedule");
+                schedule.Delete();
+              }
+
+              Log.Write("Scheduler: Spawned record once schedule, resetting timer");
+              ResetTimer(); //lets process the spawned once schedule at once.
+            }
+          }
+        }
+      }
+
+      //  Series link schedule never records directly
+      return false;
+    }
+
     private RecordingDetail IsTimeToRecordWeekly(Schedule schedule, DateTime currentTime, out bool isTimeToRecord)
     {
       isTimeToRecord = false;
@@ -832,6 +920,8 @@
 
         if (once == null) // make sure that we DO NOT create multiple once recordings.
         {
+          Log.Write("Scheduler: Spawning record once - " + current.Description + ", start time: " + current.StartTime.ToString());
+
           Schedule newSchedule = new Schedule(schedule);
           newSchedule.IdChannel = current.IdChannel;
           newSchedule.StartTime = current.StartTime;
@@ -845,6 +935,9 @@
         }
       }
 
+      if (!isSpawnedOnceScheduleCreated)
+        Log.Write("Scheduler: Once recording already scheduled");
+
       return isSpawnedOnceScheduleCreated;
     }
 
Index: TvEngine3/TVLibrary/TvService/TvService.csproj
===================================================================
--- TvEngine3/TVLibrary/TvService/TvService.csproj	(revision 27484)
+++ TvEngine3/TVLibrary/TvService/TvService.csproj	(working copy)
@@ -10,7 +10,7 @@
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{3BE4F3AA-36EB-4956-B000-E29C74FC6AB0}</ProjectGuid>
     <OutputType>WinExe</OutputType>
@@ -142,6 +142,10 @@
     </EmbeddedResource>
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\..\Common-MP-TVE3\DirectShowLib\DirectShowLib.csproj">
+      <Project>{CE009BFA-5EF6-4153-B2A1-2FA79698A9AE}</Project>
+      <Name>DirectShowLib</Name>
+    </ProjectReference>
     <ProjectReference Include="..\Plugins\PluginBase\PluginBase.csproj">
       <Project>{5EE20DC0-B22B-4BDB-828B-8DC5723A1873}</Project>
       <Name>PluginBase</Name>
